
Motorola 68000
==============

PC Relative Addressing Mode
---------------------------

This addressing mode is needed for position independent code,
something that can be important on the Amiga system since code
loaded by the OS is relocatable.  The mode works like this:

      lea (0x10,pc), a2

This create code that looks like this:

    0x0000: 45fa lea (16,PC), a2
            0010

The generated instuction is 4 bytes (two 16 bit words).  The value
loaded in a2 is calcuated as:  a2 = PC + 16 where PC is calculated
from the word after the instruction.  So:

    a2 = 0x0002 + 0x0010 = 0x0012

The offset added to PC can be a number between -32768 to 32767, so
around 32k.  The awkward part currently implemented in naken_asm is
that the offset is always assembled as the offset.  So doing something
like:

   .org 0x1000
   start:
     lea (data,pc), a2

   .org 0x2000
     dc16 0

Will translate to lea (0x2000,pc), a2 instead of lea (0xffe,pc), a2.
To get the correct result this can be done with:

   .org 0x1000
   start:
     lea (data-$-2,pc), a2

   .org 0x2000
     dc16 0

There is a couple ways this could be taken care of in the future.  One
posibility is recognizing the "data" is a label and having the assembler
automatically assume the user wants the offset from PC.  The other thing
would be to add new syntax so lea (@data,pc), a2 tells the assembler that
the user wants the offset to data (minus 2) instead of the address.

