;; BME680 - Environmental Sensor
;;
;; Date: July 27, 2019
;; Author: Michael Kohn
;; Email: mike@mikekohn.net
;; Web: https://www.mikekohn.net/
;;
;; Part of the naken_asm project

;; i2c registers (the SPI registers are labeled with SPI).

BME680_STATUS     equ 0x73
BME680_RESET      equ 0xe0
BME680_ID         equ 0xd0
BME680_CONFIG     equ 0x75
BME680_CTRL_MEAS  equ 0x74
BME680_CTRL_HUM   equ 0x72
BME680_CTRL_GAS_1 equ 0x71
BME680_CTRL_GAS_0 equ 0x70

BME680_SPI_RESET  equ 0x60
BME680_SPI_ID     equ 0x50

BME680_GAS_WAIT_0 equ 0x64
BME680_GAS_WAIT_1 equ 0x65
BME680_GAS_WAIT_2 equ 0x66
BME680_GAS_WAIT_3 equ 0x67
BME680_GAS_WAIT_4 equ 0x68
BME680_GAS_WAIT_5 equ 0x69
BME680_GAS_WAIT_6 equ 0x6a
BME680_GAS_WAIT_7 equ 0x6b
BME680_GAS_WAIT_8 equ 0x6c
BME680_GAS_WAIT_9 equ 0x6d

BME680_RES_HEAT_0 equ 0x5a
BME680_RES_HEAT_1 equ 0x5b
BME680_RES_HEAT_2 equ 0x5c
BME680_RES_HEAT_3 equ 0x5d
BME680_RES_HEAT_4 equ 0x5e
BME680_RES_HEAT_5 equ 0x5f
BME680_RES_HEAT_6 equ 0x60
BME680_RES_HEAT_7 equ 0x61
BME680_RES_HEAT_8 equ 0x62
BME680_RES_HEAT_9 equ 0x63

BME680_LDAC_HEAT_0 equ 0x50
BME680_LDAC_HEAT_1 equ 0x51
BME680_LDAC_HEAT_2 equ 0x52
BME680_LDAC_HEAT_3 equ 0x53
BME680_LDAC_HEAT_4 equ 0x54
BME680_LDAC_HEAT_5 equ 0x55
BME680_LDAC_HEAT_6 equ 0x56
BME680_LDAC_HEAT_7 equ 0x57
BME680_LDAC_HEAT_8 equ 0x58
BME680_LDAC_HEAT_9 equ 0x59

BME680_GAS_R_LSB    equ 0x2b
BME680_GAS_R_MSB    equ 0x2a
BME680_HUM_LSB      equ 0x26
BME680_HUM_MSB      equ 0x25
BME680_TEMP_XLSB    equ 0x24
BME680_TEMP_LSB     equ 0x23
BME680_TEMP_MSB     equ 0x22
BME680_PRESS_XLSB   equ 0x21
BME680_PRESS_LSB    equ 0x20
BME680_PRESS_MSB    equ 0x1f
BME680_MEAS_STATUS_0 equ 0x1d


